/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.sql;

import com.jiuqi.sql.DBException;
import java.util.ArrayList;
import java.util.List;

public class SQLPretreatment {
    private String originSQL;
    private String sql;
    private List params;
    private boolean toUpperCase = false;
    private boolean ignoreComment = false;
    private static final char[] BLANK_SET = new char[]{' ', '\t', '\r', '\n'};

    public SQLPretreatment(String sql) {
        this.originSQL = sql;
        sql = null;
        this.params = new ArrayList();
    }

    public void execute() throws DBException {
        this.reset();
        StringBuffer sqlBuffer = new StringBuffer();
        this.build(sqlBuffer);
        this.sql = sqlBuffer.toString().trim();
    }

    public String getSQL() {
        return this.sql;
    }

    public String[] getParamNames() {
        return this.params.toArray(new String[0]);
    }

    public void setToUpperCase(boolean toUpperCase) {
        this.toUpperCase = toUpperCase;
    }

    public boolean getToUpperCase() {
        return this.toUpperCase;
    }

    public void setIgnoreComment(boolean ignoreComment) {
        this.ignoreComment = ignoreComment;
    }

    public boolean getIgnoreComment() {
        return this.ignoreComment;
    }

    private void reset() {
        this.sql = null;
        this.params.clear();
    }

    private char convertChar(char ch) {
        return this.toUpperCase ? Character.toUpperCase(ch) : ch;
    }

    private void build(StringBuffer buffer) throws DBException {
        CharReader reader = new CharReader();
        block8: while (!reader.isEnd()) {
            char ch = reader.read();
            switch (ch) {
                case 'G': 
                case 'g': {
                    if (reader.check(-1, BLANK_SET) && reader.check(0, new char[]{'o', 'O'}) && reader.check(1, BLANK_SET)) {
                        return;
                    }
                    buffer.append(this.convertChar(ch));
                    break;
                }
                case '\u0000': 
                case ';': {
                    break block8;
                }
                case '-': {
                    if (reader.peek() == '-') {
                        reader.read();
                        if (!this.ignoreComment) {
                            buffer.append("--");
                        }
                        this.gotoNextLine(reader, buffer);
                        break;
                    }
                    buffer.append(ch);
                    break;
                }
                case '/': {
                    if (reader.peek() == '*') {
                        reader.read();
                        if (!this.ignoreComment) {
                            buffer.append("/*");
                        }
                        this.gotoCommentEnd(reader, buffer);
                        break;
                    }
                    buffer.append(ch);
                    break;
                }
                case '\'': {
                    buffer.append(ch);
                    if (this.readToStringEnd(reader, buffer)) continue block8;
                    throw new DBException("SQL语法错误：含有未结束的字符串！");
                }
                case '?': {
                    buffer.append(ch);
                    String paramName = this.readParamName(reader);
                    this.params.add(paramName);
                    break;
                }
                default: {
                    buffer.append(this.convertChar(ch));
                }
            }
        }
    }

    private void gotoNextLine(CharReader reader, StringBuffer buffer) {
        while (!reader.isEnd()) {
            char ch = reader.read();
            if (ch == '\r' || ch == '\n') {
                buffer.append(ch);
                break;
            }
            if (this.ignoreComment) continue;
            buffer.append(ch);
        }
    }

    private void gotoCommentEnd(CharReader reader, StringBuffer buffer) {
        while (!reader.isEnd()) {
            char ch = reader.read();
            if (ch == '*' && reader.peek() == '/') {
                reader.read();
                buffer.append(this.ignoreComment ? " " : "*/");
                break;
            }
            if (this.ignoreComment) continue;
            buffer.append(ch);
        }
    }

    private boolean readToStringEnd(CharReader reader, StringBuffer buffer) {
        while (!reader.isEnd()) {
            char ch = reader.read();
            buffer.append(ch);
            if (ch != '\'') continue;
            return true;
        }
        return false;
    }

    private String readParamName(CharReader reader) {
        StringBuffer paramName = new StringBuffer();
        while (!reader.isEnd()) {
            char ch = reader.peek();
            if (!(ch >= 'a' && ch <= 'z' || ch >= 'A' && ch <= 'Z' || ch >= '0' && ch <= '9' || ch == '_') && ch != '@') break;
            paramName.append(ch);
            reader.read();
        }
        return paramName.toString();
    }

    private class CharReader {
        private int curPos = 0;
        public static final char EOF = '\u0000';

        private CharReader() {
        }

        public boolean isEnd() {
            return SQLPretreatment.this.originSQL == null || this.curPos >= SQLPretreatment.this.originSQL.length();
        }

        public char read() {
            if (this.isEnd()) {
                return '\u0000';
            }
            return SQLPretreatment.this.originSQL.charAt(this.curPos++);
        }

        public char peek() {
            if (this.isEnd()) {
                return '\u0000';
            }
            return SQLPretreatment.this.originSQL.charAt(this.curPos);
        }

        public char peekNext() {
            if (SQLPretreatment.this.originSQL == null) {
                return '\u0000';
            }
            return this.curPos + 1 >= SQLPretreatment.this.originSQL.length() ? (char)'\u0000' : SQLPretreatment.this.originSQL.charAt(this.curPos + 1);
        }

        public char peek(int offset) {
            if (SQLPretreatment.this.originSQL == null) {
                return '\u0000';
            }
            int newPos = this.curPos + offset;
            return newPos < 0 || newPos >= SQLPretreatment.this.originSQL.length() ? (char)'\u0000' : SQLPretreatment.this.originSQL.charAt(newPos);
        }

        public boolean check(int offset, char[] charSet) {
            if (charSet == null) {
                return false;
            }
            char ch = this.peek(offset);
            int i = 0;
            while (i < charSet.length) {
                if (charSet[i] == ch) {
                    return true;
                }
                ++i;
            }
            return false;
        }
    }
}

